import java.util.*;
// Este programa ejecuta la Criba de Erasttenes.
// para computar nmeros hasta 1.000.000. 
public class CribaEras extends BitSet{
    long start, end;
    int count, i;
    public CribaEras(int n){
        super(n);
        start = System.currentTimeMillis();
        count = 0;
        for (i = 2; i <= n; i++) set(i);
        i = 2;
        while (i * i <= n){  
            if (get(i)){  
                count++;
                int k = 2 * i;
                while (k <= n){  
                    clear(k);
                    k += i;
                }   //  while
            }   // if
            i++;
        }   // while
        while (i <= n){  
            if (get(i)) count++;
            i++;
        }
        end =  System.currentTimeMillis();
     }

    public String toString(){
        String aux = "Criba de Erasttenes 1..1000000\n";
        aux+= count + " primos\n";
        aux+= (end - start) + " milisegundos\n";      
        aux+= "Primeros 10 primos \n";
        for(int i = 0, cont = 0; cont < 10 && i < 1000;i++)
           if (get(i)){ 
              aux+=i + ", ";
              cont++;
           }
        return aux;
    }       
    
    public static void main(String[] s){
        CribaEras criba = new CribaEras(1000000);
        System.out.println(criba);
    }
}

